{

MSPACMAN - By Oldbitcollector
With a lot help from: Trodoss & Ahle2

V008 (a) - changes to address Hydra/Hydra-like display issues
 
}

CON
  ' Proto/Demo Board setup
   _clkmode  = xtal1 + pll16x
   _xinfreq  = 5_000_000

   TV_BASE_PIN = 12
   KEYSPIN   = 26
'{   
'  ' Hydra setup
'  _CLKMODE = xtal1 + pll8x
'  _XINFREQ = 10_000_000 + 0000

'   TV_BASE_PIN = 24 
'   KEYSPIN  = 13   
'}

{
' Hybrid Boards
   _clkmode  = xtal1 + pll16x
   _xinfreq  = 6_000_000
   
   TV_BASE_PIN = 24    
   KEYSPIN  = 12 
}


'' gamepad pin configuration (adjust for your setup)
  JOY_CLK = 3
  JOY_LCH = 4
  JOY_DATAOUT0 = 5
  JOY_DATAOUT1 = 6 

'' audio configuration
  RIGHT_CHANNEL = 10
  LEFT_CHANNEL  = 11
  
  ' NES bit encodings for NES gamepad 0
  NES0_RIGHT    = %00000000_00000001
  NES0_LEFT     = %00000000_00000010
  NES0_DOWN     = %00000000_00000100
  NES0_UP       = %00000000_00001000
  NES0_START    = %00000000_00010000
  NES0_SELECT   = %00000000_00100000
  NES0_B        = %00000000_01000000
  NES0_A        = %00000000_10000000  

  COLOR_BLACK  = $02
  COLOR_BROWN  = $5d
  COLOR_YELLOW = $6e
  COLOR_WHITE  = $07
  COLOR_GREEN  = $9e
  COLOR_RED    = $6b
  COLOR_PURPLE = $3b
  COLOR_CYAN   = $58
  COLOR_BLUE   = $78
  

  'direction constants
  DIR_SOUTH = 0
  DIR_NORTH = 2
  DIR_WEST  = 4
  DIR_EAST  = 6
  
  'map size constants
  MAP_WIDTH      = 19
  MAP_HEIGHT     = 21
  MAP_SIZE_BYTES = MAP_WIDTH * MAP_HEIGHT

VAR
  word Nes_Pad
  
  byte maparray [MAP_SIZE_BYTES] 


  byte frameCounter
OBJ
  text   : "ORE_TV_Text_008"  'the TV display driver
  key    : "comboKeyboard"  
  pst    : "Parallax Serial Terminal" 
  
PUB start | i 

     pst.Start(115200)
     text.start(TV_BASE_PIN)               
     key.start(KEYSPIN)
     
     
    'MSPACMAN LOGO
     text.PokeChar(10,6,COLOR_WHITE,COLOR_RED,COLOR_BLUE,$01)
     text.PokeChar(11,6,COLOR_WHITE,COLOR_RED,COLOR_BLUE,$02)
     text.PokeChar(12,6,COLOR_WHITE,COLOR_RED,COLOR_BLUE,$02)

     text.PokeChar(10,8,COLOR_WHITE,COLOR_PURPLE,COLOR_BLUE,$03)
     text.PokeChar(11,8,COLOR_WHITE,COLOR_PURPLE,COLOR_BLUE,$04)

     text.PokeChar(10,10,COLOR_WHITE,COLOR_RED,COLOR_BLUE,$05)
     text.PokeChar(11,10,COLOR_WHITE,COLOR_RED,COLOR_BLUE,$06)

     text.PokeChar(10,12,COLOR_WHITE,COLOR_RED,COLOR_BLUE,$07)
     text.PokeChar(11,12,COLOR_WHITE,COLOR_RED,COLOR_BLUE,$08)
     
    
     text.UpdateScreen 
     
    'BEGIN MAIN GAME LOOP
    repeat

  
        
PRI NES_Read_Gamepad : nes_bits        |  i
' //////////////////////////////////////////////////////////////////
' NES Game Paddle Read
' //////////////////////////////////////////////////////////////////       
' reads both gamepads in parallel encodes 8-bits for each in format
' right game pad #1 [15..8] : left game pad #0 [7..0]
'
' set I/O ports to proper direction
' P3 = JOY_CLK      (4)
' P4 = JOY_SH/LDn   (5) 
' P5 = JOY_DATAOUT0 (6)
' P6 = JOY_DATAOUT1 (7)
' NES Bit Encoding
'
' RIGHT  = %00000001
' LEFT   = %00000010
' DOWN   = %00000100
' UP     = %00001000
' START  = %00010000
' SELECT = %00100000
' B      = %01000000
' A      = %10000000

' step 1: set I/Os
DIRA [JOY_CLK] := 1 ' output
DIRA [JOY_LCH] := 1 ' output
DIRA [JOY_DATAOUT0] := 0 ' input
DIRA [JOY_DATAOUT1] := 0 ' input

' step 2: set clock and latch to 0
OUTA [JOY_CLK] := 0 ' JOY_CLK = 0
OUTA [JOY_LCH] := 0 ' JOY_SH/LDn = 0
'Delay(1)

' step 3: set latch to 1
OUTA [JOY_LCH] := 1 ' JOY_SH/LDn = 1
'Delay(1)                            

' step 4: set latch to 0
OUTA [JOY_LCH] := 0 ' JOY_SH/LDn = 0

' data is now ready to shift out, clear storage
nes_bits := 0

' step 5: read 8 bits, 1st bits are already latched and ready, simply save and clock remaining bits
repeat i from 0 to 7

 nes_bits := (nes_bits << 1)
 nes_bits := nes_bits | INA[JOY_DATAOUT0] | (INA[JOY_DATAOUT1] << 8)

 OUTA [JOY_CLK] := 1 ' JOY_CLK = 1
 'Delay(1)             
 OUTA [JOY_CLK] := 0 ' JOY_CLK = 0
 
 'Delay(1)             
' invert bits to make positive logic
nes_bits := (!nes_bits & $FFFF)

' Keyboard (mapped onto NES buttons)
    if(key.keystate($C2))       'Up Arrow
      nes_bits|=NES0_UP
    if(key.keystate($C3))       'Down Arrow
      nes_bits|=NES0_DOWN
    if(key.keystate($C0))       'Left Arrow
      nes_bits|=NES0_LEFT
    if(key.keystate($C1))       'Right Arrow
      nes_bits|=NES0_RIGHT
    if(key.keystate($0D))       'Enter
      nes_bits|=NES0_START
    if(key.keystate(" "))       'Space
      nes_bits|=NES0_B

' //////////////////////////////////////////////////////////////////
' End NES Game Paddle Read
' //////////////////////////////////////////////////////////////////             
 